<?php

namespace app\controllers;

use Yii;
use app\models\Demographics;
use app\models\Riskbehavior;
use app\models\RiskbehaviorSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl; 
use app\models\Attandance;

/**
 * RiskbehaviorController implements the CRUD actions for Riskbehavior model.
 */
class RiskbehaviorController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['error'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['index', 'create', 'update', 'view', 'delete', 'sex','visit'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Riskbehavior models.
     * @return mixed
     */
	 
 /* public function actionList()
    {
        $request = Yii::$app->request;
        if ($request->isPost)
            $id = $request->post('id');

        $model = Demographics::find()->where(["Demographics_part_id" => $id])->andWhere("Demographics_q1=1")->orderBy("create_time DESC")->one();
        if ($model !== null) {
            \Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
            return $model;
        } else {
            return "No Male Participant";
        }
    }
*/

 public function actionSex()
    {
        $request = Yii::$app->request;
        if ($request->isPost)
            $id = $request->post('id');

        $model = Demographics::find()->where(["demographics_part_id" => $id])->orderBy("create_time ASC")->one();
        if ($model !== null) {		
         if ($model->demographics_q1 ==1) {
            return "Male Participant";
        }
		else if ($model->demographics_q1 ==2) {
            return "Female Participant";
        }
		else if ($model->demographics_q1 ==3) {
            return "Hijra Participant";
        }
		else {
			 return "Invalid Sex";
			
		}
			
        } 
    }
 	
	
    public function actionIndex()
    {
        $searchModel = new RiskbehaviorSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Riskbehavior model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Riskbehavior model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
	 public function actionCreate()
    {
        $model = new Riskbehavior();

        if (Yii::$app->request->isAjax && $model->load(Yii::$app->request->post())) {
            Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
            return \yii\widgets\ActiveForm::validate($model);
        }

        // if ($model->load(Yii::$app->request->post()) && $model->save()) {
        if ($model->load(Yii::$app->request->post())) {
            if($model->save())
                return $this->redirect(['view', 'id' => $model->risk_behavior_id]);
            else {
                return $this->render('create', [
                    'model' => $model,
                ]);
            }
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }
	
    
    /**
     * Updates an existing Riskbehavior model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
     public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if (Yii::$app->request->isAjax && $model->load(Yii::$app->request->post())) {
            Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
            return \yii\widgets\ActiveForm::validate($model);
        }

        // if ($model->load(Yii::$app->request->post()) && $model->save()) {
        if ($model->load(Yii::$app->request->post())) {
            if($model->save())
                return $this->redirect(['view', 'id' => $model->risk_behavior_id]);
            else {
                return $this->render('update', [
                    'model' => $model,
                ]);
            }
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Riskbehavior model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['/'.Yii::$app->controller->id]);
    }

    /**
     * Finds the Riskbehavior model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Riskbehavior the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Riskbehavior::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
	public function actionVisit()
    {
        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->request;
        if ($request->isGet)
            $id = $request->get('pid');
        if ($request->isPost)
            $id = $request->post('pid');
		$today = strtotime(date("Y/m/d"));
		
        $model = Attandance::find()->where(["participant_id" => $id])->andWhere(["=", "visit", 1])->andWhere(["record_date" => $today])->orderBy(['record_date' => SORT_DESC])->one();
		if ($model !== null) {	
         return $model;
		} 
    }
}
